'AK - dod. funkcje
'TEXTJOIN(delimiter, ign_empty, text1_or_range,...)
'  PL: POCZ.TEKSTY()
'or ConcatStrArray(CellsRange, Delim=";", InsEmpty=False)
'or CONCAT(text1_or_range, ...)
'  PL: ZCZ.TEKST()
'SWITCH(expr, val1, result1, ..., default)
'  PL: PRZECZ()
'IFS(test1, val1, test2, val2, ...)
'  PL: WARUNKI()

Attribute VB_Name = "Module1"
Option Explicit

Function TEXTJOIN(delimiter As String, ignore_empty As Boolean, ParamArray text_ranges() As Variant) As String
'Concatenating text from a specified ranges (or arrays) into one string(in o.365/2016+ use std. TEXTJOIN).
'czenie tekstw z podanych zakresw (lub tablic) w jeden tekst (w o.365/2016+ uyj std. POCZ.TEKSTY).

  Dim CellsRange As Variant
  Dim R As Variant
  Dim Result, s As String
  Dim i As Integer
  Result = ""
  For i = LBound(text_ranges) To UBound(text_ranges)
    CellsRange = text_ranges(i)
    If Not IsArray(CellsRange) Then CellsRange = Array(CellsRange)
    For Each R In CellsRange
      s = R
      If Not ignore_empty Or Len(s) > 0 Then Result = Result & s & delimiter
    Next R
  Next i
  If Len(Result) >= Len(delimiter) Then 'delete last delimiter
    Result = Left(Result, Len(Result) - Len(delimiter))
  End If
  TEXTJOIN = Result
End Function

Function CONCAT(ParamArray text_ranges() As Variant) As String
'CONCAT(text1 or range, text2 ...)
  Dim CellsRange As Variant
  Dim R As Variant
  Dim Result, s As String
  Dim i As Integer
  Result = ""
  For i = LBound(text_ranges) To UBound(text_ranges)
    CellsRange = text_ranges(i)
    If Not IsArray(CellsRange) Then CellsRange = Array(CellsRange)
    For Each R In CellsRange
      s = R
      Result = Result & s
    Next R
  Next i
  CONCAT = Result
End Function

Function ConcatStrArray(CellsRange As Variant, Optional Delimiter As String = ";", Optional InsertEmpty As Boolean = False) As String
'czenie tekstw z podanego zakresu (lub tablicy) w jeden tekst.
'Concatenating text from a specified range (or array) into one string.
  ConcatStrArray = TEXTJOIN(Delimiter, Not InsertEmpty, CellsRange)
End Function

Function SWITCH(expression As Variant, ParamArray valueN_resultN() As Variant) As Variant
'SWITCH(expression, value1, result1, [default or value2, result2],[default or valueN, resultN])
'  PL: PRZECZ()
'Description 
'Expression (required) is the value (such as a number, date or some text) that will be compared against value1value126.
'ValueN is a value that will be compared against expression.
'ResultN is the value to be returned when the corresponding valueN argument matches expression. ResultN and must be supplied for each corresponding valueN argument.
'Default (optional) is the value to return in case no matches are found in the valueN expressions. The Default argument is identified by having no corresponding resultN expression (see examples). 
  Dim i As Integer
  For i = LBound(valueN_resultN) To UBound(valueN_resultN) Step 2
    If i + 1 > UBound(valueN_resultN) Then
      SWITCH = valueN_resultN(i)
      Exit Function
    Else
      If valueN_resultN(i) = expression Then
        SWITCH = valueN_resultN(i+1)
        Exit Function
      End If
    End If
  Next i
  SWITCH = CVErr(xlErrNA)
End Function

Function IFS(ParamArray testN_valueN() As Variant) As Variant
'IFS(logical_test1, value_if_true1, [logical_test2, value_if_true2], [logical_test3, value_if_true3],)
'PL: WARUNKI()
'Description
'Expression (required) is the value (such as a number, date or some text) that will be compared against value1value126.
'ValueN is a value that will be compared against expression.
'ResultN is the value to be returned when the corresponding valueN argument matches expression. ResultN and must be supplied for each corresponding valueN argument.
'Default (optional) is the value to return in case no matches are found in the valueN expressions. The Default argument is identified by having no corresponding resultN expression (see examples). 
  Dim i As Integer
  For i = LBound(testN_valueN) To UBound(testN_valueN) Step 2
    If i + 1 > UBound(testN_valueN) Then
      IFS = CVErr(xlErrNA)
      Exit Function
    Else
      If testN_valueN(i) Then
        IFS = testN_valueN(i+1)
        Exit Function
      End If
    End If
  Next i
  IFS = CVErr(xlErrNA)
End Function
